(function(){
var additionalData = [
["title.html","CTR-Pia Measurement Information",
"CTR-Pia Measurement Information\nVersion 4.3.0\n\tNintendo Confidential\n\tThe content of this document is highly confidential and should be handled accordingly.\nThe content of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned in whole or in part without the prior approval of Nintendo.\nThis document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.No part of this document may be released, distributed, transmitted or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2012–2014 Nintendo. All rights reserved.\nAll company and product names in this document are the trademarks or registered trademarks of their respective companies.\nCTR-06-0278-001-K\n",0]
,["Pages/Page_19988951.html","PiaTransport CPU Load Measurement",
"PiaTransport CPU Load Measurement\n(Changed the title from the previous, \"PiaSession CPU Load Measurement Information.\")\nLists the results of CPU load measurements under a few conditions, using the session/ProfilingTest verification program included in tests.\nThe measurement conditions for rendering and sound processing differ significantly from those of a normal retail product. Refer to these measurements as just one guideline for development.\nThese estimates derive the CPU load for communication by subtracting the load for processes other than communication from the processing load that includes communication, with a single CPU core on the application side working at full capacity taken to be 100%.\nMeasurements that are expected to have some variation in the results are remeasured as needed. Assume that measurements that were not remeasured have only a small variation from the previous version.\n",0]
,["Pages/Page_19988951.html","Measurement Conditions",
"Measurement Conditions\n \tCTR-Pia \t4.3.0 equivalent\n \tCTR-NEX \t3.8.0\n \tCTR-SDK \t10.1.0\n \tFirmware \t0.23.5\n \tARMCC \t4.1 b1049\n Build: fast / Release (enhanced application)\nGame frame rate: 30 frames per second\n NEX thread mode (used in PiaSession Internet communication): ThreadModeUnsafeTransportBuffer\nSignature during communication: MD5\nDispatch is called twice for each game frame.\nUse the IS-SNAKE DevKit connected wirelessly.\n",0]
,["Pages/Page_19988951.html","Measurement Results",
"Measurement Results\nThe measurement values are written as (host)/(client).\n",0]
,["Pages/Page_19988951.html","UnreliableProtocol",
"UnreliableProtocol\nEach send is 512 bytes of data, which is sent to all of the other stations for every game frame.\n \t \t4 units \t8 units\n \tUnreliable - Local \t1.45% / 1.41% \t2.23% / 2.21%\n \tUnreliable - Internet \t1.53% / 1.53% \t 2.50% / 2.46%\n ",0]
,["Pages/Page_19988951.html"," ",
"\n",0]
,["Pages/Page_19988951.html","Reliable Protocol",
"Reliable Protocol\nEach send is 128 bytes of data, which is sent to all of the other stations once for every two game frames.\n \t \t4 units \t8 units\n \tReliable - Local \t1.42% / 1.38% \t2.74% / 2.62%\n \tReliable - Internet \t1.47% / 1.42% \t 2.35% / 2.34%\n",0]
,["Pages/Page_19988951.html","Reference: Build as a Standard Application",
"Reference: Build as a Standard Application\n",0]
,["Pages/Page_19988951.html","Unreliable Protocol",
"Unreliable Protocol\n \t \t8 units\n \tUnreliable - Internet \t9.46% / 9.63%\nCONFIDENTIAL\n",0]
,["Pages/Page_19988952.html","PiaSync CPU Load Measurement",
"PiaSync CPU Load Measurement\nLists the results of CPU load measurements under a few conditions, using the sync/SyncProtocolProfiling verification program included in tests.\nThe measurement conditions for rendering and sound processing differ significantly from those of a normal retail product. Refer to these measurements as just one guideline for development.\nThese estimates derive the CPU load for communication by subtracting the load for processes other than communication from the processing load that includes communication, with a single CPU core on the application side working at full capacity taken to be 100%.\nMeasurements that are expected to have some variation in the results are remeasured as needed. Assume that measurements that were not remeasured have only a small variation from the previous version.\n",0]
,["Pages/Page_19988952.html","Measurement Conditions",
"Measurement Conditions\n \tCTR-Pia \t4.3.0 equivalent\n \tCTR-NEX \t3.8.0\n \tCTR-SDK \t10.1.0\n \tFirmware \t0.23.5\n \tARMCC \t4.1 b1049\n Build: fast / Release (enhanced application)\nGame frame rate: 30 frames per second\nShared data size: 12 + 5 + 8 bytes (using three data IDs)\nSend frequency (SyncProtocol::Setting::m_SendPeriod): 1\nSignature during communication: MD5\nDispatch is called twice for each game frame.\nUse the IS-SNAKE DevKit connected wirelessly.\n",0]
,["Pages/Page_19988952.html","Measurement Results",
"Measurement Results\nThe measurement values are written as (host)/(client).\nDelay buffer: 5 game frames\n",0]
,["Pages/Page_19988952.html","SyncProtocol",
"SyncProtocol\n \t \t4 units \t8 units\n \tSync - Local \t1.21% / 1.24% \t1.77% / 1.78%\n \tSync - Internet \t1.25% / 1.27% \t1.89% / 1.85%\n Frame drops are 2% each or less.\n",0]
,["Pages/Page_19988952.html","Reference: Build as a Standard Application",
"Reference: Build as a Standard Application\n",0]
,["Pages/Page_19988952.html","Sync Protocol ",
"Sync Protocol\n \t \t8 units\n \tSync - Internet \t7.26% / 7.20%\nCONFIDENTIAL\n",0]
,["Pages/Page_19988953.html","PiaSession Memory Usage Measurement",
"PiaSession Memory Usage Measurement\nLists the results of memory usage measurements under a few conditions using the session/ProfilingTest verification program included in tests.\nThe measurement conditions for rendering and sound processing differ significantly from those of a normal retail product. Refer to these measurements as just one guideline for development.\nYou can individually set the size of each of the communication buffers at Pia initialization. In measurements, the peak value of each of the communication buffers is measured during communication, and the memory size for those peak values when set for the communication buffers of all stations is taken as the Pia memory usage.\nMeasurements that are expected to have some variation in the results are remeasured as needed. Assume that measurements that were not remeasured have only a small variation from the previous version.\n",0]
,["Pages/Page_19988953.html","Measurement Conditions",
"Measurement Conditions\n \tCTR-Pia \t4.3.0 equivalent\n \tCTR-NEX \t3.8.0\n \tCTR-SDK \t10.1.0\n \tFirmware \t0.23.5\n \tARMCC \t4.1 b1049\n Build: fast / Release (enhanced application)\nGame frame rate: 30 frames per second\nNEX thread mode (used in PiaSession Internet communication): ThreadModeUnsafeTransportBuffer\nSignature during communication: MD5\nDispatch is called twice for each game frame.\nUse the IS-SNAKE DevKit connected wirelessly.\n",0]
,["Pages/Page_19988953.html","Measurement Results",
"Measurement Results\nThe measurement values are written as\nLocal Communication: (Amount of memory used by Pia)\nInternet Communication: (Pia memory usage) + (NEX server service memory usage)\n",0]
,["Pages/Page_19988953.html","Unreliable Protocol",
"Unreliable Protocol\nEach send is 512 bytes of data, which is sent to all of the other stations for every game frame.\n \t \t4 units \t 8 units\n \tUnreliable - Local \t332.5 (KB) \t466.3 (KB)\n \tUnreliable - Internet \t286.1 + 344.7 = 630.8 (KB) \t447.5 + 344.7 = 792.2 (KB)\n",0]
,["Pages/Page_19988953.html","Reliable Protocol",
"Reliable Protocol\nEach send is 128 bytes of data, which is sent to all of the other stations once for every two game frames.\n \t \t4 units \t8 units\n \tReliable - Local \t342.7 (KB) \t509.3 (KB)\n \tReliable - Internet \t297.5 + 344.7 = 642.2 (KB) \t483.3 + 343.0 = 826.3 (KB)\nCONFIDENTIAL\n",0]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
