var TemplateSettings = function(){};
TemplateSettings.javaScriptPath = 'template/js/common/';
TemplateSettings.templateLibFileName = 'manualLib.js';
TemplateSettings.templateTocFileName = 'tocData.js';
TemplateSettings.templateTitleFileName = 'title.html';
TemplateSettings.settingAttrId = 'data-reassemble';
TemplateSettings.selectorTocFile = 'script[src$="' + TemplateSettings.templateTocFileName + '"]';
TemplateSettings.documentRootPath = 'contents/';
TemplateSettings.divTreePaneId = 'contents_tree';
TemplateSettings.styleTreePane = 'treeitem_root';
TemplateSettings.openIconPath = 'template/img/icon_folder_open.png';
TemplateSettings.closeIconPath = 'template/img/icon_folder_close.png';
TemplateSettings.fileIconPath = 'template/img/icon_file.png';
TemplateSettings.styleOpenTreeItemDiv = 'treeitem_open';
TemplateSettings.styleCloseTreeItemDiv = 'treeitem_close';
TemplateSettings.styleIconLineDiv = 'listline';
TemplateSettings.styleNoIconLineDiv = 'listline_file';
TemplateSettings.styleOpenTreeItemImg = 'openfolder';
TemplateSettings.styleCloseTreeItemImg = 'closefolder';
TemplateSettings.styleFileTreeItemImg = 'file';
TemplateSettings.styleHeaderLineSpan = 'header';
TemplateSettings.styleItemLineSpan = 'item';
TemplateSettings.styleSeparatorLine = 'separator';
TemplateSettings.foldedTreeItemAttrId = 'data-folded';
TemplateSettings.globalindexContentWidth = 265;
TemplateSettings.globalindexToggleWidth = 15;
TemplateSettings.globalindexPanePadH = 32;
TemplateSettings.autoindexContentWidth = 250;
TemplateSettings.autoindexToggleWidth = 15;
TemplateSettings.autoindexFocusOffset = 15;
TemplateSettings.autoindexContentPadW = 32;
TemplateSettings.autoindexContentId = 'autoindex_content';
TemplateSettings.autoindexWrapperId = 'autoindex_wrapper';
TemplateSettings.autoindexTabId = 'autoindex_tab';
TemplateSettings.autoindexToggleId = 'autoindex_toggle';
TemplateSettings.autoindexToggleAttrId = 'data-toggle';
TemplateSettings.globalindexWrapperId = 'globalindex_wrapper';
TemplateSettings.globalindexTabId = 'globalindex_tab';
TemplateSettings.globalindexToggleId = 'globalindex_toggle';
TemplateSettings.globalindexToggleAttrId = 'data-toggle';
TemplateSettings.globalindexRootPaneId = 'rootPane';
TemplateSettings.titleLogoDivId = 'logo';
TemplateSettings.titleTocDivId = 'toc_title';
TemplateSettings.selectCategoryId = 'selectCategory';
TemplateSettings.printControllerId = 'printController';
TemplateSettings.treeControllerId = 'treeController';
TemplateSettings.changeViewModeIdPrefix = 'changeViewMode_';
TemplateSettings.expandDivIdPrefix = 'Label_';
TemplateSettings.expandImgIdPrefix = 'Img_';
TemplateSettings.styleAutoindexContent = 'autoindex_content';
TemplateSettings.styleAutoindexWrapper = 'autoindex_wrapper';
TemplateSettings.styleAutoindexTab = 'autoindex_index';
TemplateSettings.styleAutoindexToggle = 'autoindex_toggle';
TemplateSettings.styleAutoindexContent = 'autoindex_content';
TemplateSettings.styleTitleLogoDiv = 'logo';
TemplateSettings.styleTitleTocDiv = 'toc_title';
TemplateSettings.styleSelectCategory = 'selectCategory';
TemplateSettings.searchFileName = 'search.html';
TemplateSettings.searchBoxMiniFormName = 'form_searchbox_mini';
TemplateSettings.searchBoxMiniDivId = 'searchbox_mini';
TemplateSettings.searchBoxMiniDivStyle = 'searchbox_mini_div';
TemplateSettings.searchBoxMiniTextStyle = 'searchbox_mini_text';
TemplateSettings.searchBoxMiniButtonStyle = 'searchbox_mini_button';
TemplateSettings.searchMessageLineStyle = 'search_message_line';
TemplateSettings.searchResultDigestLength = 100;
TemplateSettings.searchResultCountPerPage = 20;
TemplateSettings.cookieKeyAutoindexToggle = 'autoindexToggle';
TemplateSettings.cookieKeyGlobalindexToggle = 'globalindexToggle';
TemplateSettings.cookieKeyViewmode = 'reassembleViewMode';
TemplateSettings.apiIframeId = 'iframe_api';
TemplateSettings.apiIframePadW = 4;
TemplateSettings.apiIframePadH = 4;
TemplateSettings.guidelineDescIdPrefix = 'description_';
TemplateSettings.guidelineDescLabelPrefix = 'GuidelineDescLabel_';
TemplateSettings.guidelineDescAnchorPrefix = 'Desc_';
TemplateSettings.guidelineItemIdPrefix = 'itemDesc_';
TemplateSettings.guidelineItemLabelPrefix = 'GuidelineItemLabel_';
TemplateSettings.guidelineItemAnchorPrefix = 'guidelineitem_';
var LocaleString = function(){};
LocaleString.lcStrMessageNeedJQuery = '\u30b9\u30af\u30ea\u30d7\u30c8\u306e\u5b9f\u884c\u306b\u306f jQuery \u304c\u5fc5\u8981\u3067\u3059\u3002';
LocaleString.lcStrMessageNothingToc = '\u76ee\u6b21\u30c7\u30fc\u30bf\u30d5\u30a1\u30a4\u30eb\uff08' + TemplateSettings.templateTocFileName + '\uff09\u306e\u5185\u5bb9\u304c\u6b63\u3057\u304f\u3042\u308a\u307e\u305b\u3093\u3002';
LocaleString.lcStrLabelModeAll = '\u3059\u3079\u3066';
LocaleString.lcStrLabelModeDesc = '\u89e3\u8aac\u66f8\u306e\u307f';
LocaleString.lcStrLabelModeItem = '\u30ac\u30a4\u30c9\u30e9\u30a4\u30f3\u9805\u76ee\u306e\u307f';
LocaleString.lcStrLabelSelectChapter = '-- \u9078\u629e\u3057\u305f\u7b87\u6240\u30921\u30da\u30fc\u30b8\u3067\u8868\u793a\u3057\u307e\u3059 --';
LocaleString.lcStrLabelSelectAll = '\uff08\u3059\u3079\u3066\uff09';
LocaleString.lcStrLabelFigure = '\u56f3 ';
LocaleString.lcStrLabelTable = '\u8868 ';
LocaleString.lcStrLabelCode = '\u30b3\u30fc\u30c9 ';
LocaleString.lcStrLabelAcTopLevel = '\uff08\u30da\u30fc\u30b8\u306e\u5148\u982d\uff09';
LocaleString.lcStrMessageSearching = '\u691c\u7d22\u4e2d\u3067\u3059\u3002\u3057\u3070\u3089\u304f\u304a\u5f85\u3061\u304f\u3060\u3055\u3044...';
LocaleString.lcStrLabelSearchResult = '\u691c\u7d22\u7d50\u679c\uff1a %r% \u4ef6';
LocaleString.lcStrLabelSearchView = '\uff08%s% - %e% \u4ef6\u76ee\u3092\u8868\u793a\u4e2d\uff09';
LocaleString.lcStrLabelSearchPrev = '\u524d\u306e%c%\u4ef6\u3092\u8868\u793a';
LocaleString.lcStrLabelSearchNext = '\u6b21\u306e%c%\u4ef6\u3092\u8868\u793a';
LocaleString.lcStrLabelStartSearch = '\u691c\u7d22';
LocaleString.lcStrLabelDefinition = '\u5b9a\u7fa9\u5185\u5bb9';
LocaleString.lcStrLabelTestMethod = '\u30c6\u30b9\u30c8\u65b9\u6cd5';
LocaleString.lcStrLabelCriterion = '\u5408\u683c\u57fa\u6e96';
LocaleString.lcStrLabelTestObject = '\u5bfe\u8c61';
LocaleString.lcStrLabelExclusion = '\u9664\u5916\u30b1\u30fc\u30b9';
LocaleString.lcStrLabelRemarks = '\u5099\u8003';
var ExpandFolder = function(){};
if(typeof jQuery != 'function')
{
  alert(LocaleString.lcStrMessageNeedJQuery);
  ExpandFolder.rootURL = ''
}
else
  ExpandFolder.rootURL = $('script[src$="' + TemplateSettings.templateLibFileName + '"]').attr('src') ? $('script[src$="' + TemplateSettings.templateLibFileName + '"]').attr('src').replace(TemplateSettings.javaScriptPath + TemplateSettings.templateLibFileName,'') : '';
ExpandFolder.openIconPath = ExpandFolder.rootURL + TemplateSettings.openIconPath;
ExpandFolder.closeIconPath = ExpandFolder.rootURL + TemplateSettings.closeIconPath;
ExpandFolder.fileIconPath = ExpandFolder.rootURL + TemplateSettings.fileIconPath;
ExpandFolder.styleOpenDiv = TemplateSettings.styleOpenTreeItemDiv;
ExpandFolder.styleCloseDiv = TemplateSettings.styleCloseTreeItemDiv;
ExpandFolder.styleLineIconDiv = TemplateSettings.styleIconLineDiv;
ExpandFolder.styleLineNoIconDiv = TemplateSettings.styleNoIconLineDiv;
ExpandFolder.styleOpenImg = TemplateSettings.styleOpenTreeItemImg;
ExpandFolder.styleCloseImg = TemplateSettings.styleCloseTreeItemImg;
ExpandFolder.styleFileImg = TemplateSettings.styleFileTreeItemImg;
ExpandFolder.attributeFolded = TemplateSettings.foldedTreeItemAttrId;
ExpandFolder.selectorTreePaneDiv = 'div#' + TemplateSettings.divTreePaneId;
ExpandFolder.selectorOpenItemDiv = ExpandFolder.selectorTreePaneDiv + ' div[class=' + TemplateSettings.styleOpenTreeItemDiv + ']';
ExpandFolder.selectorCloseItemDiv = ExpandFolder.selectorTreePaneDiv + ' div[class=' + TemplateSettings.styleCloseTreeItemDiv + ']';
ExpandFolder.selectorOpenItemImg = ExpandFolder.selectorTreePaneDiv + ' img[class=' + TemplateSettings.styleOpenTreeItemImg + ']';
ExpandFolder.selectorCloseItemImg = ExpandFolder.selectorTreePaneDiv + ' img[class=' + TemplateSettings.styleCloseTreeItemImg + ']';
ExpandFolder.selectorFileItemImg = ExpandFolder.selectorTreePaneDiv + ' img[class=' + TemplateSettings.styleFileTreeItemImg + ']';
ExpandFolder.expandDivIdPrefix = TemplateSettings.expandDivIdPrefix;
ExpandFolder.expandImgIdPrefix = TemplateSettings.expandImgIdPrefix;
ExpandFolder.initExpandFolder = function()
{
  $(ExpandFolder.selectorOpenItemDiv).each(function()
  {
    $(this).css('display','block').attr(ExpandFolder.attributeFolded,false)
  });
  $(ExpandFolder.selectorCloseItemDiv).each(function()
  {
    $(this).css('display','none').attr(ExpandFolder.attributeFolded,true)
  });
  $(ExpandFolder.selectorOpenItemImg).each(function()
  {
    $(this).attr('src',ExpandFolder.openIconPath)
  });
  $(ExpandFolder.selectorCloseItemImg).each(function()
  {
    $(this).attr('src',ExpandFolder.closeIconPath)
  });
  $(ExpandFolder.selectorFileItemImg).each(function()
  {
    $(this).attr('src',ExpandFolder.fileIconPath)
  })
};
ExpandFolder.openAll = function()
{
  $(ExpandFolder.selectorOpenItemDiv + ',' + ExpandFolder.selectorCloseItemDiv).each(function()
  {
    $(this).css('display','block').attr(ExpandFolder.attributeFolded,false)
  });
  $(ExpandFolder.selectorCloseItemImg).each(function()
  {
    $(this).attr('src',ExpandFolder.openIconPath).attr('class',ExpandFolder.styleOpenImg)
  })
};
ExpandFolder.closeAll = function()
{
  $(ExpandFolder.selectorOpenItemDiv + ',' + ExpandFolder.selectorCloseItemDiv).each(function()
  {
    $(this).css('display','none').attr(ExpandFolder.attributeFolded,true)
  });
  $(ExpandFolder.selectorOpenItemImg).each(function()
  {
    $(this).attr('src',ExpandFolder.closeIconPath).attr('class',ExpandFolder.styleCloseImg)
  })
};
ExpandFolder.expand = function(id, objCaller)
{
  $('#' + id).each(function()
  {
    var isObjDisplay = $(this).css('display') == 'block';
    $(this).css('display',isObjDisplay ? 'none' : 'block').attr(ExpandFolder.attributeFolded,isObjDisplay);
    $(objCaller).attr('src',isObjDisplay ? ExpandFolder.closeIconPath : ExpandFolder.openIconPath).attr('class',isObjDisplay ? ExpandFolder.styleCloseImg : ExpandFolder.styleOpenImg)
  })
};
function TocDataObject(type, category, level, url, id, text, baselevel, figure, table, code)
{
  this.dataType = type;
  this.dataCategory = category;
  this.dataLevel = level;
  this.dataURL = url;
  this.dataID = id;
  this.dataText = text;
  this.dataBaselevel = baselevel;
  this.dataFigureNo = figure;
  this.dataTableNo = table;
  this.dataCodeNo = code;
  this.expand = false;
  this.viewIcon = true;
  this.dataQuery = '';
  this.dataLabel = '';
  this.dataExpandLabel = ''
}
TocDataObject.prototype = {
  getType: function()
  {
    return this.dataType
  },
  getCategory: function()
  {
    return this.dataCategory
  },
  getLevel: function()
  {
    return this.dataLevel
  },
  getURL: function()
  {
    return this.dataURL
  },
  getID: function()
  {
    return this.dataID
  },
  getText: function()
  {
    return this.dataText
  },
  getBaselevel: function()
  {
    return this.dataBaselevel
  },
  getFigureNo: function()
  {
    return this.dataFigureNo
  },
  getTableNo: function()
  {
    return this.dataTableNo
  },
  getCodeNo: function()
  {
    return this.dataCodeNo
  },
  enableExpand: function()
  {
    this.expand = true
  },
  isExpandFolder: function()
  {
    return this.expand
  },
  setQuery: function(str)
  {
    this.dataQuery = str == null ? '' : str
  },
  getQuery: function()
  {
    return this.dataQuery
  },
  setFigureNo: function(no)
  {
    this.dataFigureNo = no == null || no < 0 ? 0 : no
  },
  setTableNo: function(no)
  {
    this.dataTableNo = no == null || no < 0 ? 0 : no
  },
  setCodeNo: function(no)
  {
    this.dataCodeNo = no == null || no < 0 ? 0 : no
  },
  setLabel: function(str)
  {
    this.dataLabel = str == null ? '' : str
  },
  getLabel: function()
  {
    return this.dataLabel
  },
  setExpandLabel: function(str)
  {
    this.dataExpandLabel = str == null ? '' : str
  },
  getExpandLabel: function()
  {
    return this.dataExpandLabel
  },
  enableViewIcon: function()
  {
    this.viewIcon = true
  },
  disableViewIcon: function()
  {
    this.viewIcon = false
  },
  isViewIcon: function()
  {
    return this.viewIcon
  }
};
function TocObject()
{
  this.logoFile = '';
  this.logoWidth = 0;
  this.logoHeight = 0;
  this.titleName = '';
  this.titleFile = TemplateSettings.templateTitleFileName;
  this.windowTitleName = '';
  this.displayNumber = false;
  this.modeAnchor = true;
  this.targetName = '';
  this.windowWidth = 280;
  this.openWithExpand = false;
  this.viewFileIcon = true;
  this.printPage = false;
  this.insertTitlePage = false;
  this.baselevel = 0;
  this.figureNo = 0;
  this.tableNo = 0;
  this.codeNo = 0;
  this.currentURL = '';
  this.countGuideline = 1;
  this.rootURL = '';
  this.searchEnabled = true;
  this.arrayData = new Array;
  this.arrayData.length = 0;
  this.setLogoFile = function(file)
  {
    this.logoFile = file == null ? '' : file
  };
  this.getLogoFile = function()
  {
    return this.logoFile
  };
  this.setLogoSize = function(width, height)
  {
    this.logoWidth = width == null || width < 0 ? 0 : width;
    this.logoHeight = height == null || height < 0 ? 0 : height
  };
  this.getLogoWidth = function()
  {
    return this.logoWidth
  };
  this.getLogoHeight = function()
  {
    return this.logoHeight
  };
  this.setTitle = function(title)
  {
    this.titleName = title == null ? '' : title
  };
  this.getTitle = function()
  {
    return this.titleName
  };
  this.setWindowTitle = function(title)
  {
    this.windowTitleName = title == null ? '' : title
  };
  this.getWindowTitle = function()
  {
    return this.windowTitleName
  };
  this.setTitleFile = function(file)
  {
    this.titleFile = file == null ? '' : file
  };
  this.getTitleFile = function()
  {
    return this.titleFile
  };
  this.setTargetName = function(name)
  {
    this.targetName = name == null ? '' : name
  };
  this.getTargetName = function()
  {
    return this.targetName
  };
  this.isEnableTarget = function()
  {
    return this.targetName != ''
  };
  this.setWindowWidth = function(width)
  {
    this.windowWidth = width == null || width < 0 ? 0 : width
  };
  this.getWindowWidth = function()
  {
    return this.windowWidth
  };
  this.enableDisplayNumber = function()
  {
    this.displayNumber = true
  };
  this.disableDisplayNumber = function()
  {
    this.displayNumber = false
  };
  this.isDisplayNumber = function()
  {
    return this.displayNumber
  };
  this.setOpenWithExpand = function(enable)
  {
    this.openWithExpand = enable
  };
  this.isOpenWithExpand = function()
  {
    return this.openWithExpand
  };
  this.setBaselevel = function(level)
  {
    this.baselevel = level == null || level < 0 ? 0 : level
  };
  this.getBaselevel = function()
  {
    return this.baselevel
  };
  this.setFigureNo = function(no)
  {
    this.figureNo = no == null || no < 0 ? 0 : no
  };
  this.getFigureNo = function()
  {
    return this.figureNo
  };
  this.addFigureNo = function(num)
  {
    var no = parseInt(num);
    if(isNaN(num))
      no = 1;
    this.figureNo += no
  };
  this.setTableNo = function(no)
  {
    this.tableNo = no == null || no < 0 ? 0 : no
  };
  this.getTableNo = function()
  {
    return this.tableNo
  };
  this.addTableNo = function(num)
  {
    var no = parseInt(num);
    if(isNaN(num))
      no = 1;
    this.tableNo += no
  };
  this.setCodeNo = function(no)
  {
    this.codeNo = no == null || no < 0 ? 0 : no
  };
  this.getCodeNo = function()
  {
    return this.codeNo
  };
  this.addCodeNo = function(num)
  {
    var no = parseInt(num);
    if(isNaN(num))
      no = 1;
    this.codeNo += no
  };
  this.setAnchorMode = function()
  {
    this.modeAnchor = true
  };
  this.setGetMode = function()
  {
    this.modeAnchor = false
  };
  this.isAnchorMode = function()
  {
    return this.modeAnchor
  };
  this.isGetMode = function()
  {
    return!this.modeAnchor
  };
  this.enableViewFileIcon = function()
  {
    this.viewFileIcon = true
  };
  this.disableViewFileIcon = function()
  {
    this.viewFileIcon = false
  };
  this.enablePrintPage = function()
  {
    this.printPage = true
  };
  this.disablePrintPage = function()
  {
    this.printPage = false
  };
  this.isEnablePrintPage = function()
  {
    return this.printPage
  };
  this.setInsertTitlePage = function(flag)
  {
    this.insertTitlePage = flag
  };
  this.isEnableInsertTitlePage = function()
  {
    return this.insertTitlePage
  };
  this.setRootURL = function(url)
  {
    this.rootURL = url == null ? '' : url
  };
  this.getRootURL = function()
  {
    return this.rootURL
  };
  this.setSearchEnabled = function(flag)
  {
    this.searchEnabled = flag
  };
  this.isEnabledSearch = function()
  {
    return this.searchEnabled
  };
  this.getDataArray = function()
  {
    return this.arrayData
  };
  this.getDataCount = function()
  {
    return this.arrayData.length
  };
  this.getData = function(no)
  {
    if(no < 0 || no >= this.getDataCount())
      return null;
    return this.arrayData[no]
  };
  this._addTocDataObjectCore = function(type, category, level, name, url, id)
  {
    if(level <= this.baselevel)
    {
      this.figureNo = 1;
      this.tableNo = 1;
      this.codeNo = 1
    }
    var data = new TocDataObject(type,category,level,url,id,name,this.baselevel,this.figureNo,this.tableNo,this.codeNo);
    this.arrayData.push(data)
  };
  this.addSectionHeader = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('MAN_HEADER',category,level,name,url,id)
  };
  this.addSection = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('MAN',category,level,name,url,id)
  };
  this.addHeader = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('HEADER',category,level,name,url,id)
  };
  this.addItem = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('ITEM',category,level,name,url,id)
  };
  this.addGuidelineSection = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('GUIDELINE_SECTION',category,level,name,url,id);
    this.currentURL = url;
    this.countGuideline = 1
  };
  this.addGuidelineHeader = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('GUIDELINE_HEADER',category,level,name,url,id);
    this.currentURL = url;
    this.countGuideline = 1
  };
  this.addGuidelineDesc = function(category, level, name, url, id)
  {
    this._addTocDataObjectCore('GUIDELINE',category,level,name,url,id);
    this.currentURL = url;
    this.countGuideline = 1
  };
  this.addGuidelineItem = function(category, level, name)
  {
    if(level <= this.baselevel)
    {
      this.figureNo = 1;
      this.tableNo = 1;
      this.codeNo = 1
    }
    var data = new TocDataObject('GUIDELINE',category,level,this.currentURL,TemplateSettings.guidelineItemAnchorPrefix + this.countGuideline,name,this.baselevel,this.figureNo,this.tableNo,this.codeNo);
    data.disableViewIcon();
    this.arrayData.push(data);
    this.countGuideline++
  };
  this.addSeparator = function()
  {
    this.figureNo = 1;
    this.tableNo = 1;
    this.codeNo = 1;
    var data = new TocDataObject('SEPARATOR','',0,'','','',this.figureNo,this.tableNo,this.codeNo);
    this.arrayData.push(data)
  };
  this.addBlankLine = function()
  {
    this.figureNo = 1;
    this.tableNo = 1;
    this.codeNo = 1;
    var data = new TocDataObject('BLANK','',0,'','','',this.figureNo,this.tableNo,this.codeNo);
    this.arrayData.push(data)
  };
  this.addExternal = function(category, level, name, url)
  {
    this._addTocDataObjectCore('EXTERNAL',category,level,name,url,'')
  };
  this.makeAnchorURL = function(data)
  {
    if(data == null)
      return'';
    var level = '';
    var label = '';
    var url = '';
    var text = '';
    if(data.getType().match(/^man|^guideline/i))
    {
      level = '?level=' + data.getQuery() + '&figure=' + data.getFigureNo() + '&table=' + data.getTableNo() + '&code=' + data.getCodeNo();
      label = data.getLabel()
    }
    url = data.getURL();
    text = (this.isDisplayNumber() && label != '' ? label + ' ' : '') + data.getText();
    if(url == '')
      url = text;
    else
    {
      var target = this.isEnableTarget() ? ' target="' + this.getTargetName() + '"' : '';
      var id = data.getID() == '' ? '' : '#' + data.getID();
      if(data.getType().match(/^external/i))
        url = '<a href="' + this.rootURL + 'external.html?file=' + url + '"' + target + '>' + text + '</a>';
      else
        url = '<a href="' + this.rootURL + url + level + id + '"' + target + '>' + text + '</a>'
    }
    return url
  };
  this.makeGetURL = function(data)
  {
    if(data == null)
      return'';
    var url = '';
    var text = '';
    var label = '';
    var level = '';
    var figure = '';
    var table = '';
    var code = '';
    if(data.getType().match(/^man|^guideline/i))
    {
      level = data.getQuery();
      label = data.getLabel();
      figure = data.getFigureNo();
      table = data.getTableNo();
      code = data.getCodeNo()
    }
    url = data.getURL();
    var displayNumber = data.getType().match(/section/i) ? false : this.isDisplayNumber();
    text = (this.isDisplayNumber() && label != '' ? label + ' ' : '') + data.getText();
    if(url == '')
      url = text;
    else
    {
      var target = this.isEnableTarget() ? this.getTargetName() : '';
      var id = data.getID() == '' ? '' : '#' + data.getID();
      if(data.getType().match(/^external/i))
        url = '<a href="javascript: Guideline.viewPage(\'' + this.rootURL + 'external.html?file=' + url + '\',\'' + target + '\',\'1\',1,1,1);">' + text + '</a>';
      else
        url = '<a href="javascript: Guideline.viewPage(\'' + this.rootURL + url + id + '\',\'' + target + '\',\'' + level + '\',' + figure + ',' + table + ',' + code + ');">' + text + '</a>'
    }
    return url
  };
  this.processTreeData = function()
  {
    var prevURL = '';
    var arrayLevel = new Array(9);
    for(var x = 0; x < 9; x++)
      arrayLevel[x] = 0;
    var prevLevel = 999;
    var prevData = null;
    for(var i = 0; i < this.getDataCount(); i++)
    {
      var label = '';
      var query = '';
      var expandLabel = '';
      var data = this.getData(i);
      var currentLevel = data.getLevel();
      var baselevel = data.getBaselevel();
      var dataType = data.getType();
      var currentURL = data.getURL();
      if(currentLevel > prevLevel)
        if(i > 0)
          this.getData(i - 1).enableExpand();
      arrayLevel[currentLevel] = arrayLevel[currentLevel] + 1;
      for(var n = currentLevel + 1; n < 9; n++)
        arrayLevel[n] = 0;
      if(dataType.match(/separator|blank/i))
      {
        arrayLevel[0] = arrayLevel[0] - 1;
        if(arrayLevel[0] < 0)
          arrayLevel[0] = 0
      }
      for(var n = 0; n < 9; n++)
        if(arrayLevel[n] > 0)
        {
          expandLabel += (n > 0 ? '_' : '') + arrayLevel[n];
          var x = n - baselevel;
          if(x >= 0)
          {
            query += (x > 0 ? ',' : '') + arrayLevel[n];
            if(x < 4)
              label += arrayLevel[n] + '.';
            else
              label = ''
          }
        }
      if(currentURL == prevURL && currentURL != '' && i > 0)
      {
        data.setQuery(prevData.getQuery());
        data.setFigureNo(prevData.getFigureNo());
        data.setTableNo(prevData.getTableNo());
        data.setCodeNo(prevData.getCodeNo())
      }
      else
      {
        data.setQuery(query);
        prevData = data
      }
      data.setLabel(label);
      data.setExpandLabel(expandLabel);
      prevLevel = currentLevel;
      prevURL = currentURL
    }
  };
  this.createContents = function()
  {
    var file = this.getLogoFile();
    if(file != '')
    {
      var elem = document.getElementById(TemplateSettings.titleLogoDivId);
      if(elem != null)
      {
        var obj = document.createElement('IMG');
        obj.src = this.rootURL + file;
        var width = this.getLogoWidth();
        var height = this.getLogoHeight();
        if(width > 0)
          obj.width = width;
        if(height > 0)
          obj.height = height;
        elem.appendChild(obj)
      }
    }
    var title = this.getTitle();
    var elem = document.getElementById(TemplateSettings.titleTocDivId);
    if(elem != null)
    {
      var obj = document.createElement('A');
      obj.href = this.rootURL + this.getTitleFile();
      if(this.isEnableTarget())
        obj.target = this.getTargetName();
      obj.innerHTML = title;
      elem.appendChild(obj)
    }
    if(this.isEnabledSearch())
    {
      var elem = document.getElementById(TemplateSettings.searchBoxMiniDivId);
      if(elem != null)
      {
        elem.className = TemplateSettings.searchBoxMiniDivStyle;
        var obj = document.createElement('FORM');
        obj.name = TemplateSettings.searchBoxMiniFormName;
        obj.action = this.rootURL + TemplateSettings.searchFileName;
        obj.method = 'GET';
        var formHtml = '';
        formHtml += '<input type="text" name="q" class="' + TemplateSettings.searchBoxMiniTextStyle + '"> ';
        formHtml += '<input type="submit" class="' + TemplateSettings.searchBoxMiniButtonStyle + '" value="' + LocaleString.lcStrLabelStartSearch + '">';
        obj.innerHTML = formHtml;
        elem.appendChild(obj)
      }
    }
    if(this.getWindowTitle() != '')
      document.title = this.getWindowTitle();
    else if(document.title == '')
      document.title = this.getTitle();
    var elem = document.getElementById(TemplateSettings.printControllerId);
    if(elem != null)
    {
      var str = '';
      str += '<select id="' + TemplateSettings.selectCategoryId + '" name="category" size="1" class="' + TemplateSettings.styleSelectCategory + '" onChange="Reassemble.viewPrintPage();">' + '<option value="">' + LocaleString.lcStrLabelSelectChapter + '</option>' + '</select><br />';
      if(this.isEnablePrintPage())
      {
        elem.innerHTML += str;
        elem.style.display = 'block';
        var selectObj = document.getElementById(TemplateSettings.selectCategoryId);
        if(selectObj != null)
        {
          for(var i = 0; i < this.getDataCount(); i++)
          {
            var data = this.getData(i);
            if(data != null && data.getType().match(/section/i))
            {
              var optObj = document.createElement('OPTION');
              optObj.innerHTML = (data.getType().match(/^man|^guideline/i) && this.isDisplayNumber() && data.getLabel() != '' ? data.getLabel() + ' ' : '') + data.getText();
              optObj.value = data.getCategory();
              selectObj.appendChild(optObj)
            }
          }
          var optObj = document.createElement('OPTION');
          optObj.innerHTML = LocaleString.lcStrLabelSelectAll;
          optObj.value = '*';
          selectObj.appendChild(optObj)
        }
      }
    }
    var prev = 0;
    var objDIVs = new Array(9);
    for(var x = 0; x < 9; x++)
      objDIVs[x] = null;
    var rootObj = document.getElementById(TemplateSettings.divTreePaneId);
    if(rootObj != null)
    {
      objDIVs[0] = rootObj;
      for(var i = 0; i < this.getDataCount(); i++)
      {
        var data = this.getData(i);
        if(data == null)
          continue;
        var current = data.getLevel();
        var dataType = data.getType();
        var dataLabel = data.getLabel();
        var dataExpandLabel = data.getExpandLabel();
        if(current < prev)
          for(var x = prev; x > current; x--)
            objDIVs[x - 1].appendChild(objDIVs[x]);
        var objDIV = document.createElement('DIV');
        objDIV.className = ExpandFolder.styleLineIconDiv;
        if(dataType.match(/^separator$/i))
          objDIV.innerHTML = '<hr class="' + TemplateSettings.styleSeparatorLine + '">';
        else if(dataType.match(/^blank$/i))
          objDIV.innerHTML = '<br>';
        else
        {
          var objSPAN = document.createElement('SPAN');
          if(dataType.match(/header|section/i))
            objSPAN.className = TemplateSettings.styleHeaderLineSpan;
          else
            objSPAN.className = TemplateSettings.styleItemLineSpan;
          if(this.modeAnchor)
            objSPAN.innerHTML = this.makeAnchorURL(data);
          else if(dataType.match(/^man|^guideline/i))
            objSPAN.innerHTML = this.makeGetURL(data);
          else
            objSPAN.innerHTML = this.makeAnchorURL(data);
          var objIMG = document.createElement('IMG');
          if(data.isExpandFolder())
          {
            objIMG.src = this.isOpenWithExpand() ? ExpandFolder.openIconPath : ExpandFolder.closeIconPath;
            objIMG.className = this.isOpenWithExpand() ? ExpandFolder.styleOpenImg : ExpandFolder.styleCloseImg;
            objIMG.onclick = new Function('ExpandFolder.expand(\'' + ExpandFolder.expandDivIdPrefix + data.getExpandLabel() + '\', this);');
            objIMG.id = ExpandFolder.expandImgIdPrefix + ExpandFolder.expandDivIdPrefix + data.getExpandLabel();
            objDIV.appendChild(objIMG)
          }
          else if(!this.viewFileIcon || !data.isViewIcon())
            objDIV.className = ExpandFolder.styleLineNoIconDiv;
          else
          {
            objIMG.src = ExpandFolder.fileIconPath;
            objIMG.className = ExpandFolder.styleFileImg;
            objDIV.appendChild(objIMG)
          }
          objDIV.appendChild(objSPAN)
        }
        objDIVs[current].appendChild(objDIV);
        if(data.isExpandFolder())
        {
          var objDIV = document.createElement('DIV');
          objDIV.className = this.isOpenWithExpand() ? ExpandFolder.styleOpenDiv : ExpandFolder.styleCloseDiv;
          objDIV.id = ExpandFolder.expandDivIdPrefix + data.getExpandLabel();
          objDIV.setAttribute(ExpandFolder.attributeFolded,!this.isOpenWithExpand());
          objDIVs[current + 1] = objDIV
        }
        prev = current
      }
      for(var x = prev; x > 0; x--)
        objDIVs[x - 1].appendChild(objDIVs[x])
    }
  }
}
var Reassemble = function(){};
Reassemble.autoindexContentWidth = TemplateSettings.autoindexContentWidth;
Reassemble.autoindexToggleWidth = TemplateSettings.autoindexToggleWidth;
Reassemble.globalindexContentWidth = TemplateSettings.globalindexContentWidth;
Reassemble.globalindexToggleWidth = TemplateSettings.globalindexToggleWidth;
Reassemble.settingAttrId = TemplateSettings.settingAttrId;
Reassemble.autoindexContentId = TemplateSettings.autoindexContentId;
Reassemble.autoindexWrapperId = TemplateSettings.autoindexWrapperId;
Reassemble.autoindexTabId = TemplateSettings.autoindexTabId;
Reassemble.autoindexToggleId = TemplateSettings.autoindexToggleId;
Reassemble.autoindexToggleAttrId = TemplateSettings.autoindexToggleAttrId;
Reassemble.globalindexWrapperId = TemplateSettings.globalindexWrapperId;
Reassemble.globalindexTabId = TemplateSettings.globalindexTabId;
Reassemble.globalindexToggleId = TemplateSettings.globalindexToggleId;
Reassemble.globalindexToggleAttrId = TemplateSettings.globalindexToggleAttrId;
Reassemble.globalindexRootPaneId = TemplateSettings.globalindexRootPaneId;
Reassemble.styleAutoindexContent = TemplateSettings.styleAutoindexContent;
Reassemble.styleAutoindexWrapper = TemplateSettings.styleAutoindexWrapper;
Reassemble.styleAutoindexTab = TemplateSettings.styleAutoindexTab;
Reassemble.styleAutoindexToggle = TemplateSettings.styleAutoindexToggle;
Reassemble.selectorAutoindexContentDiv = 'div#' + Reassemble.autoindexContentId;
Reassemble.selectorAutoindexWrapperDiv = 'div#' + Reassemble.autoindexWrapperId;
Reassemble.selectorAutoindexTabDiv = 'div#' + Reassemble.autoindexTabId;
Reassemble.selectorAutoindexToggleDiv = 'div#' + Reassemble.autoindexToggleId;
Reassemble.selectorGlobalindexWrapperDiv = 'div#' + Reassemble.globalindexWrapperId;
Reassemble.selectorGlobalindexTabDiv = 'div#' + Reassemble.globalindexTabId;
Reassemble.selectorGlobalindexToggleDiv = 'div#' + Reassemble.globalindexToggleId;
Reassemble.objectTocData = null;
Reassemble.autoindexEnabled = false;
Reassemble.globalindexEnabled = false;
Reassemble.autoindexScrollTarget = null;
Reassemble.globalindexScrollTarget = null;
Reassemble.viewMode = '0';
Reassemble.str2int = function(str)
{
  if(str == null)
    return 0;
  var val = parseInt(str);
  if(isNaN(val))
    val = 0;
  return val
};
Reassemble.setEventHandler = function(eventname, func)
{
  if(eventname == null || eventname == '')
    return;
  if(func == null)
    return;
  if(window.attachEvent)
    window.attachEvent('on' + eventname,func);
  else if(window.addEventListener)
    window.addEventListener(eventname,func,false)
};
Reassemble.resizeHandler = function()
{
  if(Reassemble.autoindexEnabled || Reassemble.globalindexEnabled)
  {
    var clientHeight = $(window).height();
    var clientWidth = $(window).width();
    if(clientWidth < 400)
      return;
    var contentWidth = clientWidth;
    var autoindexWidth = 0;
    var globalindexWidth = Reassemble.globalindexContentWidth + Reassemble.globalindexToggleWidth;
    var attrAutoindexToggle = $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId);
    if(Reassemble.autoindexEnabled)
      if(attrAutoindexToggle != null && attrAutoindexToggle == '0')
      {
        $(Reassemble.selectorAutoindexTabDiv).css('display','none');
        autoindexWidth = Reassemble.autoindexToggleWidth
      }
      else
      {
        $(Reassemble.selectorAutoindexTabDiv).css('display','block');
        autoindexWidth = Reassemble.autoindexContentWidth + Reassemble.autoindexToggleWidth
      }
    var attrGlobalindexToggle = $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId);
    if(attrGlobalindexToggle != null && attrGlobalindexToggle == '0')
    {
      $(Reassemble.selectorGlobalindexTabDiv).css('display','none');
      globalindexWidth = Reassemble.globalindexToggleWidth
    }
    else
    {
      $(Reassemble.selectorGlobalindexTabDiv).css('display','block');
      globalindexWidth = Reassemble.globalindexContentWidth + Reassemble.globalindexToggleWidth;
      if($(ExpandFolder.selectorTreePaneDiv).offset() != null)
      {
        var treeOffsetTop = $(ExpandFolder.selectorTreePaneDiv).offset().top - $(window).scrollTop();
        if(clientHeight > treeOffsetTop + 200)
          $(ExpandFolder.selectorTreePaneDiv).height(clientHeight - treeOffsetTop - TemplateSettings.globalindexPanePadH)
      }
    }
    contentWidth = clientWidth - autoindexWidth - globalindexWidth - TemplateSettings.autoindexContentPadW;
    $(Reassemble.selectorAutoindexContentDiv).width(contentWidth);
    $(Reassemble.selectorAutoindexContentDiv).css('margin-left',globalindexWidth);
    $(Reassemble.selectorAutoindexContentDiv).css('margin-right',autoindexWidth);
    $(Reassemble.selectorGlobalindexTabDiv).width(Reassemble.globalindexContentWidth);
    $(Reassemble.selectorGlobalindexTabDiv).css('margin-right',-Reassemble.globalindexContentWidth);
    $(Reassemble.selectorAutoindexWrapperDiv).width(autoindexWidth);
    $(Reassemble.selectorAutoindexWrapperDiv).css('left',clientWidth - autoindexWidth);
    $(Reassemble.selectorGlobalindexWrapperDiv).width(globalindexWidth);
    $('iframe#' + TemplateSettings.apiIframeId).each(function()
    {
      $(this).width(contentWidth - TemplateSettings.apiIframePadW);
      $(this).height(clientHeight - TemplateSettings.apiIframePadH)
    });
    Reassemble.scrollHandler()
  }
};
Reassemble.scrollHandler = function()
{
  if(Reassemble.autoindexEnabled && Reassemble.autoindexScrollTarget != null)
  {
    $(Reassemble.autoindexScrollTarget).css('top',$(window).scrollTop());
    $(Reassemble.autoindexScrollTarget).css('left',$(window).width() - $(Reassemble.selectorAutoindexWrapperDiv).width() + $(window).scrollLeft())
  }
  if(Reassemble.globalindexEnabled && Reassemble.globalindexScrollTarget != null)
  {
    $(Reassemble.globalindexScrollTarget).css('top',$(window).scrollTop());
    $(Reassemble.globalindexScrollTarget).css('left',$(window).scrollLeft())
  }
  if(Reassemble.autoindexEnabled)
    Reassemble.autoindexFocusIndexInvoke()
};
Reassemble.autoindexToggleHandler = function()
{
  if(Reassemble.autoindexEnabled)
  {
    var attrToggle = $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId);
    $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId,attrToggle != null && attrToggle == '0' ? '1' : '0');
    Reassemble.resizeHandler()
  }
};
Reassemble.globalindexToggleHandler = function()
{
  if(Reassemble.globalindexEnabled)
  {
    var attrToggle = $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId);
    $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId,attrToggle != null && attrToggle == '0' ? '1' : '0');
    Reassemble.resizeHandler()
  }
};
Reassemble.autoindexFocusIndexInvoked = false;
Reassemble.selectorAutoindexFocusIndex = Reassemble.selectorAutoindexTabDiv + ' a[href*=#]';
Reassemble.autoindexFocusIndex = function()
{
  var a,
    b,
    e,
    d = $(window).scrollTop() + TemplateSettings.autoindexFocusOffset;
  $(Reassemble.selectorAutoindexFocusIndex).each(function()
  {
    var c = '#' + $(this).attr('href').split('#')[1];
    if($(c).length && $(this).parent().css('display') != 'none' && (e = $(c).offset().top, !(d < e) && (!a || b <= e)))
      a = this, b = e
  });
  $(Reassemble.selectorAutoindexFocusIndex).each(function()
  {
    Reassemble.autoindexToggleClass($(this),'focused',this == a)
  });
  Reassemble.autoindexFocusIndexInvoked = false
};
Reassemble.autoindexFocusIndexInvoke = function()
{
  Reassemble.autoindexFocusIndexInvoked || (setTimeout(Reassemble.autoindexFocusIndex,100), Reassemble.autoindexFocusIndexInvoked = true)
};
Reassemble.autoindexToggleClass = function(a, b, d)
{
  d ? a.addClass(b) : a.removeClass(b)
};
Reassemble.reassemble = function()
{
  var levels = '1';
  var figures = '';
  var tables = '';
  var codes = '';
  var forceNoIndex = false;
  var url = '';
  var q_search = '';
  var startLevel = 1;
  var endLevel = 6;
  var offsetLevel = 0;
  var autoindex = false;
  var forceDefault = false;
  var forceNolabel = false;
  var forceNoChapter = false;
  var chaseIndexURL = true;
  var chaseIndexJavaScript = true;
  var folded = false;
  var noReset = false;
  var attrBody = document.body.getAttribute(Reassemble.settingAttrId);
  if(attrBody != null)
  {
    var params = attrBody.split(',');
    for(var i = 0; i < params.length; i++)
    {
      var param = params[i];
      var ind = param.indexOf('=');
      if(ind < 0)
        continue;
      var key = decodeURIComponent(param.substring(0,ind));
      key = key.replace(/\s/g,'');
      var data = decodeURIComponent(param.slice(ind + 1));
      if(data == null)
        data = '';
      data = data.replace(/\s/g,'');
      if(key.match(/^start$/i))
        startLevel = Reassemble.str2int(data);
      else if(key.match(/^end$/i))
        endLevel = Reassemble.str2int(data);
      else if(key.match(/^autoindex$/i))
      {
        if(data.match(/^yes$|^true$/i))
          autoindex = true;
        else if(data.match(/^no$|^false$/i))
          autoindex = false
      }
      else if(key.match(/^forcedefault$/i))
      {
        if(data.match(/^yes$|^true$/i))
          forceDefault = true;
        else if(data.match(/^no$|^false$/i))
          forceDefault = false
      }
      else if(key.match(/^forcenolabel$/i))
      {
        if(data.match(/^yes$|^true$/i))
          forceNolabel = true;
        else if(data.match(/^no$|^false$/i))
          forceNolabel = false
      }
      else if(key.match(/^forcenochapter$/i))
      {
        if(data.match(/^yes$|^true$/i))
          forceNoChapter = true;
        else if(data.match(/^no$|^false$/i))
          forceNoChapter = false
      }
      else if(key.match(/^level$/i))
        levels = data.replace(/\./g,',');
      else if(key.match(/^figure$/i))
        figures = Reassemble.str2int(data);
      else if(key.match(/^table$/i))
        tables = Reassemble.str2int(data);
      else if(key.match(/^code$/i))
        codes = Reassemble.str2int(data);
      else if(key.match(/^chaseindex$/i))
      {
        if(data.match(/^yes$/i))
        {
          chaseIndexURL = true;
          chaseIndexJavaScript = true
        }
        else if(data.match(/^no$/i))
        {
          chaseIndexURL = false;
          chaseIndexJavaScript = false
        }
        else if(data.match(/^url$/i))
        {
          chaseIndexURL = true;
          chaseIndexJavaScript = false
        }
        else if(data.match(/^js$/i))
        {
          chaseIndexURL = false;
          chaseIndexJavaScript = true
        }
      }
      else if(key.match(/^offset$/i))
        offsetLevel = Reassemble.str2int(data);
      else if(key.match(/^autoindextab$/i))
      {
        if(data.match(/^fold$/i))
          folded = true;
        else if(data.match(/^open$/i))
          folded = false
      }
      else if(key.match(/^noreset$/i))
      {
        if(data.match(/^yes$|^true$/i))
          noReset = true;
        else if(data.match(/^no$|^false$/i))
          noReset = false
      }
      else if(key.match(/^forcenoindex$/i))
        if(data.match(/^yes$|^true$/i))
          forceNoIndex = true;
        else if(data.match(/^no$|^false$/i))
          forceNoIndex = false
    }
    if(startLevel < 1)
      startLevel = 1;
    if(startLevel > 6)
      startLevel = 6;
    if(endLevel > 6)
      endLevel = 6;
    if(startLevel > endLevel)
      endLevel = startLevel;
    if(offsetLevel < -5)
      offsetLevel = -5;
    if(offsetLevel > 5)
      offsetLevel = 5
  }
  var query = location.search;
  query = query.slice(query.lastIndexOf('?') + 1);
  var params = query.split('&');
  for(var i = 0; i < params.length; i++)
  {
    var param = params[i];
    var ind = param.indexOf('=');
    if(ind < 0)
      continue;
    var key = param.substring(0,ind);
    key = decodeURIComponent(key);
    key = key.replace(/\s/g,'');
    var data = decodeURIComponent(param.slice(ind + 1));
    if(data == null)
      data = '';
    data = data.replace(/\s/g,'');
    if(key.match(/^level$/i))
    {
      if(!forceDefault)
        levels = data
    }
    else if(key.match(/^figure$/i))
    {
      if(!forceDefault)
        figures = data
    }
    else if(key.match(/^table$/i))
    {
      if(!forceDefault)
        tables = data
    }
    else if(key.match(/^code$/i))
    {
      if(!forceDefault)
        codes = data
    }
    else if(key.match(/^noindex$/i))
    {
      if(data.match(/^yes$|^true$/i))
        forceNoIndex = true;
      else if(data.match(/^no$|^false$/i))
        forceNoIndex = false
    }
    else if(key.match(/^url$/i))
      url = data;
    else if(key.match(/^highlighttext$/i))
    {
      q_search = param.slice(ind + 1);
      if(q_search == null)
        q_search = '';
      var q_array = q_search.split('+');
      q_search = '';
      for(var n = 0; n < q_array.length; n++)
        q_search += (n > 0 ? ' ' : '') + decodeURIComponent(q_array[n])
    }
  }
  var arrayLevel = new Array(6);
  var arrayKeep = new Array(6);
  var figure = Reassemble.str2int(figures);
  figure = figure > 0 ? figure - 1 : 0;
  var table = Reassemble.str2int(tables);
  table = table > 0 ? table - 1 : 0;
  var code = Reassemble.str2int(codes);
  code = code > 0 ? code - 1 : 0;
  levels = levels.split(',');
  for(var i = 0; i < 6; i++)
  {
    var n = levels.length > i ? Reassemble.str2int(levels[i]) : 0;
    n = n > 0 ? n - 1 : 0;
    arrayLevel[i] = n;
    arrayKeep[i] = levels.length > i ? true : false
  }
  var baseLevel = 7;
  var baseLevelNone = 7;
  var arrayIndex = new Array;
  arrayIndex.length = 0;
  var elems;
  if(document.all)
    elems = document.all;
  else if(document.getElementsByTagName)
    elems = document.getElementsByTagName('*');
  else
    return;
  if(elems.length)
    for(var i = 0; i < elems.length; i++)
    {
      var elem = elems[i];
      var tagName = elem.tagName;
      var className = elem.className;
      var noLabel = false;
      var noChapter = false;
      var noIndex = false;
      var keep = false;
      var elemAttr = elem.getAttribute(Reassemble.settingAttrId);
      if(elemAttr != null)
      {
        var attrs = elemAttr.split(',');
        for(var x = 0; x < attrs.length; x++)
        {
          attrs[x] = attrs[x].replace(/\s/g,'');
          if(attrs[x].match(/^none$/i))
          {
            noLabel = true;
            noIndex = true
          }
          if(attrs[x].match(/^keep$/i))
            keep = true;
          if(attrs[x].match(/^nochapter$/i))
            noChapter = true;
          if(attrs[x].match(/^nolabel$/i))
            noLabel = true;
          if(attrs[x].match(/^noindex$/i))
            noIndex = true
        }
      }
      if(forceNolabel)
        noLabel = true;
      if(forceNoChapter)
        noChapter = true;
      if(tagName.match(/^H[1-6]$/i))
      {
        if(!noLabel)
        {
          var current = Reassemble.str2int(tagName.slice(1)) - startLevel + offsetLevel;
          if(current >= 0 && current <= endLevel - startLevel)
          {
            for(var x = 0; x < current; x++)
              if(arrayKeep[x])
                arrayLevel[x] = Reassemble.str2int(levels[x]);
            if(!keep)
            {
              for(var x = current + 1; x < 6; x++)
              {
                arrayLevel[x] = 0;
                arrayKeep[x] = false
              }
              if(current == 0 && !noReset)
              {
                figure = 0;
                table = 0;
                code = 0
              }
            }
            arrayLevel[current]++;
            arrayKeep[current] = false;
            var str = '';
            if(current < 4)
            {
              for(var x = 0; x <= current; x++)
                str += arrayLevel[x] + '.';
              elem.innerHTML = (noChapter ? '' : str + ' ') + elem.innerHTML
            }
          }
        }
        if(autoindex && !noIndex)
        {
          var current = Reassemble.str2int(tagName.slice(1)) - startLevel;
          if(current >= 0 && current <= endLevel - startLevel)
          {
            var elemId = elem.id;
            if(elemId == null || elemId == '')
            {
              elemId = 'autoindex_' + arrayIndex.length;
              elem.id = elemId
            }
            var data = current + '\t' + elemId + '\t' + elem.innerHTML;
            arrayIndex.push(data);
            if(!noLabel)
            {
              if(baseLevel > current)
                baseLevel = current
            }
            else if(baseLevelNone > current)
              baseLevelNone = current
          }
        }
      }
      else if(tagName.match(/^DIV$/i))
        if(!noLabel && className.match(/^figure$/i))
        {
          figure++;
          elem.innerHTML = LocaleString.lcStrLabelFigure + (noChapter ? '' : arrayLevel[0] + '-') + figure + '. ' + elem.innerHTML
        }
        else if(!noLabel && className.match(/^table$/i))
        {
          table++;
          elem.innerHTML = LocaleString.lcStrLabelTable + (noChapter ? '' : arrayLevel[0] + '-') + table + '. ' + elem.innerHTML
        }
        else if(!noLabel && className.match(/^code$/i))
        {
          code++;
          elem.innerHTML = LocaleString.lcStrLabelCode + (noChapter ? '' : arrayLevel[0] + '-') + code + '. ' + elem.innerHTML
        }
    }
  if(!forceNoIndex && autoindex && typeof jQuery == 'function')
  {
    Reassemble.autoindexEnabled = true;
    var objDivContent = document.getElementById(Reassemble.autoindexContentId);
    if(objDivContent == null)
      $('body').wrapInner('<div id="' + Reassemble.autoindexContentId + '"></div>');
    var objDivWrapper = document.getElementById(Reassemble.autoindexWrapperId);
    if(objDivWrapper == null)
      $('body').prepend('<div id="' + Reassemble.autoindexWrapperId + '"></div>');
    var objDivIndex = document.getElementById(Reassemble.autoindexTabId);
    if(objDivIndex == null)
      $(Reassemble.selectorAutoindexWrapperDiv).prepend('<div id="' + Reassemble.autoindexTabId + '"></div>');
    var objDivToggle = document.getElementById(Reassemble.autoindexToggleId);
    if(objDivToggle == null)
      $(Reassemble.selectorAutoindexWrapperDiv).prepend('<div id="' + Reassemble.autoindexToggleId + '"></div>');
    if(baseLevel > 6)
      baseLevel = baseLevelNone;
    var prev = 0;
    var strHtml = '<ul>';
    strHtml += '<li><a href="#' + Reassemble.autoindexContentId + '" class="toplevel">' + LocaleString.lcStrLabelAcTopLevel + '</a></li>';
    for(var i = 0; i < arrayIndex.length; i++)
    {
      var inds = arrayIndex[i].split('\t');
      if(inds.length > 2)
      {
        var level = Reassemble.str2int(inds[0]);
        var id = inds[1];
        var text = inds[2];
        level -= baseLevel;
        if(level < 0)
          level = 0;
        if(level < prev)
          for(var x = prev; x > level; x--)
            strHtml += '</ul>';
        else if(level > prev)
          for(var x = prev; x < level; x++)
            strHtml += '<ul>';
        strHtml += '<li><a href="#' + id + '" class="level' + level + '">' + text + '</a></li>';
        prev = level
      }
    }
    for(var x = prev; x > 0; x--)
      strHtml += '</ul>';
    $(Reassemble.selectorAutoindexContentDiv).attr('class',Reassemble.styleAutoindexContent);
    $(Reassemble.selectorAutoindexTabDiv).attr('class',Reassemble.styleAutoindexTab).html(strHtml);
    $(Reassemble.selectorAutoindexToggleDiv).attr('class',Reassemble.styleAutoindexToggle).click(Reassemble.autoindexToggleHandler);
    $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId,folded ? '0' : '1');
    var pads = ['15px','30px','40px','50px','60px','70px','70px','70px','70px','70px'];
    $(Reassemble.selectorAutoindexTabDiv + ' a').each(function()
    {
      if(this.className.match(/^level[0-9]/i))
      {
        var a = parseInt(this.className.slice(5));
        var b = '0px 0px 0px ' + pads[isNaN(a) ? '0px' : a];
        this.style.padding = b
      }
    });
    if($(Reassemble.selectorAutoindexWrapperDiv).css('position') != 'fixed')
      Reassemble.autoindexScrollTarget = document.getElementById(Reassemble.autoindexWrapperId)
  }
  if(!forceNoIndex && typeof jQuery == 'function' && $(TemplateSettings.selectorTocFile).attr('src') != null && Reassemble.objectTocData == null)
    alert(LocaleString.lcStrMessageNothingToc);
  if(!forceNoIndex && typeof jQuery == 'function' && $(TemplateSettings.selectorTocFile).attr('src') != null && Reassemble.objectTocData != null)
  {
    Reassemble.globalindexEnabled = true;
    var objDivContent = document.getElementById(Reassemble.autoindexContentId);
    if(objDivContent == null)
      $('body').wrapInner('<div id="' + Reassemble.autoindexContentId + '"></div>');
    $(Reassemble.selectorAutoindexContentDiv).attr('class',Reassemble.styleAutoindexContent);
    $('body').prepend('<div id="' + Reassemble.globalindexWrapperId + '"><div id="' + Reassemble.globalindexToggleId + '"></div><div id="' + Reassemble.globalindexTabId + '"></div></div>');
    $(Reassemble.selectorGlobalindexTabDiv).prepend('<div id="' + Reassemble.globalindexRootPaneId + '"></div>');
    $('div#' + Reassemble.globalindexRootPaneId).append('<div id="' + TemplateSettings.titleLogoDivId + '" class="' + TemplateSettings.styleTitleLogoDiv + '" align="center"></div>').append('<div id="' + TemplateSettings.titleTocDivId + '" class="' + TemplateSettings.styleTitleTocDiv + '" align="center"></div>').append('<div id="' + TemplateSettings.searchBoxMiniDivId + '" align="center"></div>').append('<div id="' + TemplateSettings.printControllerId + '" align="left"></div>').append('<div id="' + TemplateSettings.treeControllerId + '"></div>').append('<div id="' + TemplateSettings.divTreePaneId + '" class="' + TemplateSettings.styleTreePane + '"></div>');
    $('div#' + TemplateSettings.printControllerId).append('<input type="radio" id="' + TemplateSettings.changeViewModeIdPrefix + '0" name="mode" value="0" onClick="Reassemble.changeViewMode(\'0\');" checked />' + LocaleString.lcStrLabelModeAll + '<br />').append('<input type="radio" id="' + TemplateSettings.changeViewModeIdPrefix + '1" name="mode" value="1" onClick="Reassemble.changeViewMode(\'1\');" />' + LocaleString.lcStrLabelModeDesc + '<br />').append('<input type="radio" id="' + TemplateSettings.changeViewModeIdPrefix + '2" name="mode" value="2" onClick="Reassemble.changeViewMode(\'2\');" />' + LocaleString.lcStrLabelModeItem + '<br />').append('<br />');
    $('div#' + TemplateSettings.treeControllerId).append('<input type="button" value="OpenAll" onClick="ExpandFolder.openAll();" />&nbsp;').append('<input type="button" value="CloseAll" onClick="ExpandFolder.closeAll();" />');
    $(Reassemble.selectorGlobalindexToggleDiv).click(Reassemble.globalindexToggleHandler);
    $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId,'1');
    if(Reassemble.objectTocData != null)
    {
      var rootURL = $(TemplateSettings.selectorTocFile).attr('src').replace(TemplateSettings.templateTocFileName,'');
      Reassemble.objectTocData.setRootURL(rootURL);
      Reassemble.objectTocData.createContents();
      ExpandFolder.initExpandFolder()
    }
    if(chaseIndexURL || chaseIndexJavaScript)
      if(chaseIndexURL)
        Reassemble.focusIndexURL(location.href);
    if($(Reassemble.selectorGlobalindexWrapperDiv).css('position') != 'fixed')
      Reassemble.globalindexScrollTarget = document.getElementById(Reassemble.globalindexWrapperId)
  }
  if(q_search != '' && typeof jQuery == 'function')
  {
    var r_array = Search.parseQuery(q_search);
    var strReg = '';
    for(var x = 0; x < r_array.length; x++)
    {
      if(r_array[x] == '')
        continue;
      if(r_array[x].match(/^ +$/))
        continue;
      if(r_array[x].charAt(0) == '\t')
        continue;
      var str = Search.escapeRegex(r_array[x]);
      if(strReg != '')
        strReg += '|';
      strReg += str
    }
    if(strReg != '')
    {
      var objDivContent = document.getElementById(Reassemble.autoindexContentId);
      if(objDivContent != null)
        $(document).ready(Reassemble.highlightText(document,objDivContent,strReg,'search_highlight'));
      else
        $(document).ready(Reassemble.highlightText(document,document.body,strReg,'search_highlight'))
    }
  }
  Reassemble.loadSetting();
  Reassemble.changeViewMode(Reassemble.viewMode);
  Reassemble.resizeHandler();
  Reassemble.scrollHandler()
};
Reassemble.selectorGlobalindexFocusIndex = ExpandFolder.selectorTreePaneDiv + ' a';
Reassemble.focusIndexJS = function(url)
{
  if(url == null)
    return;
  url = url.replace(/\.\.\//g,'');
  var a = null;
  $(Reassemble.selectorGlobalindexFocusIndex).each(function()
  {
    var b = $(this).attr('href');
    var c = b.match(/viewPage\('([^,]+)',[^\)]+\)/i);
    var d = RegExp.$1.replace(/\.\.\//g,'');
    if(c != null && d != null && url.lastIndexOf(d) != -1)
      a = b
  });
  $(Reassemble.selectorGlobalindexFocusIndex).each(function()
  {
    $(this).attr('href') == a ? $(this).addClass('focused') : $(this).removeClass('focused')
  })
};
Reassemble.focusIndexURL = function(url)
{
  if(url == null)
    return;
  var a = null;
  $(Reassemble.selectorGlobalindexFocusIndex).each(function()
  {
    var b = $(this).attr('href');
    if(url.lastIndexOf(b.replace(/\.\.\//g,'')) != -1)
      a = b
  });
  $(Reassemble.selectorGlobalindexFocusIndex).each(function()
  {
    $(this).attr('href') == a ? $(this).addClass('focused') : $(this).removeClass('focused')
  })
};
Reassemble.setCookie = function(name, value, path)
{
  var str = '';
  str += name + '=' + encodeURIComponent(value);
  if(path)
    str += '; path=' + path;
  document.cookie = str
};
Reassemble.saveSetting = function()
{
  if(Reassemble.autoindexEnabled)
  {
    var attr = null;
    attr = $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId);
    Reassemble.setCookie(TemplateSettings.cookieKeyAutoindexToggle,attr != null ? attr : '1','/')
  }
  if(Reassemble.globalindexEnabled && document.getElementById)
  {
    var attr = null;
    attr = $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId);
    Reassemble.setCookie(TemplateSettings.cookieKeyGlobalindexToggle,attr != null ? attr : '1','/');
    $(ExpandFolder.selectorTreePaneDiv + ' div[' + ExpandFolder.attributeFolded + ']').each(function()
    {
      Reassemble.setCookie($(this).attr('id'),$(this).attr(ExpandFolder.attributeFolded),'/')
    });
    Reassemble.setCookie(TemplateSettings.cookieKeyViewmode,Reassemble.viewMode,'/')
  }
};
Reassemble.loadSetting = function()
{
  var settings = document.cookie.split(';');
  for(var n = 0; n < settings.length; n++)
  {
    var data = settings[n].split('=');
    var key = data[0].replace(/^ */,'');
    var value = decodeURIComponent(data[1]);
    if(Reassemble.autoindexEnabled)
      if(key == TemplateSettings.cookieKeyAutoindexToggle)
        $(Reassemble.selectorAutoindexWrapperDiv).attr(Reassemble.autoindexToggleAttrId,value);
    if(Reassemble.globalindexEnabled)
      if(key == TemplateSettings.cookieKeyGlobalindexToggle)
        $(Reassemble.selectorGlobalindexWrapperDiv).attr(Reassemble.globalindexToggleAttrId,value);
      else
      {
        var obj = document.getElementById(key);
        if(obj)
        {
          $(obj).css('display',value == 'true' ? 'none' : 'block').attr(ExpandFolder.attributeFolded,value);
          $('img#' + ExpandFolder.expandImgIdPrefix + key).attr('src',value == 'true' ? ExpandFolder.closeIconPath : ExpandFolder.openIconPath).attr('class',value == 'true' ? ExpandFolder.styleCloseImg : ExpandFolder.styleOpenImg)
        }
      }
    if(key == TemplateSettings.cookieKeyViewmode)
    {
      var nMode = parseInt(value);
      if(isNaN(nMode))
        nMode = 0;
      if(nMode < 0 || nMode > 2)
        nMode = 0;
      Reassemble.viewMode = '' + nMode;
      var obj = document.getElementById(TemplateSettings.changeViewModeIdPrefix + Reassemble.viewMode);
      if(obj)
        obj.checked = true
    }
  }
};
Reassemble.selectorChangeViewMode = Reassemble.selectorAutoindexTabDiv + ' ul li a[href*=#' + TemplateSettings.guidelineItemLabelPrefix + ']';
Reassemble.changeViewMode = function(mode)
{
  var nMode = parseInt(mode);
  if(isNaN(nMode))
    nMode = 0;
  if(nMode < 0 || nMode > 2)
    nMode = 0;
  Reassemble.viewMode = '' + nMode;
  if(typeof Guideline.initExpandGuideline == 'function')
  {
    Guideline.initExpandGuideline();
    if(Reassemble.autoindexEnabled)
      switch(nMode)
      {
        case 1:
          $(Reassemble.selectorChangeViewMode).parent().css('display','none');
          Reassemble.autoindexFocusIndexInvoke();
          break;
        case 0:
        case 2:
        default:
          $(Reassemble.selectorChangeViewMode).parent().css('display','block');
          Reassemble.autoindexFocusIndexInvoke();
          break
      }
  }
};
Reassemble.viewPrintPage = function()
{
  var category = $('select#' + TemplateSettings.selectCategoryId + ' option:selected').val();
  if(category != null && category != '')
    if(objTOC != null)
    {
      var rootURL = $(TemplateSettings.selectorTocFile).attr('src').replace(TemplateSettings.templateTocFileName,'');
      location.href = rootURL + 'printpage.html?category=' + encodeURIComponent(category)
    }
};
Reassemble.highlightText = function(objDocument, node, regex, className)
{
  if(node.nodeType == 3)
  {
    var val = node.nodeValue;
    var re = new RegExp(regex,'i');
    var pos = val.search(re);
    var text = re.exec(val);
    if(pos >= 0 && !$(node.parentNode).hasClass(className))
    {
      text = text[0];
      var span = objDocument.createElement("span");
      span.className = className;
      span.appendChild(objDocument.createTextNode(val.substr(pos,text.length)));
      var textNode = objDocument.createTextNode(val.substr(pos + text.length));
      node.parentNode.insertBefore(span,node.parentNode.insertBefore(textNode,node.nextSibling));
      node.nodeValue = val.substr(0,pos);
      Reassemble.highlightText(objDocument,textNode,regex,className)
    }
  }
  else if(!$(node).is("button, select, textarea"))
    $(node.childNodes).each(function()
    {
      Reassemble.highlightText(objDocument,this,regex,className)
    })
};
Reassemble.setEventHandler('load',Reassemble.reassemble);
Reassemble.setEventHandler('unload',Reassemble.saveSetting);
Reassemble.setEventHandler('scroll',Reassemble.scrollHandler);
Reassemble.setEventHandler('resize',Reassemble.resizeHandler);
var Guideline = function(){};
var countGuidelineItem = 1;
Guideline.initExpandGuideline = function()
{
  var query = location.search;
  if(query.lastIndexOf('?') != -1)
    query = query.slice(query.lastIndexOf('?') + 1);
  var params = query.split('&');
  var mode = Reassemble.viewMode;
  var level = '1';
  var figure = '1';
  var table = '1';
  var code = '1';
  var url = '';
  for(i = 0; i < params.length; i++)
  {
    var param = params[i];
    var ind = param.indexOf('=');
    if(ind < 0)
      continue;
    var key = param.substring(0,ind);
    key = decodeURIComponent(key);
    var data = decodeURIComponent(param.slice(ind + 1));
    if(key.match(/^mode$/i));
    else if(key.match(/^level$/i))
      level = data;
    else if(key.match(/^figure$/i))
    {
      figure = parseInt(data);
      if(isNaN(figure))
        figure = 0
    }
    else if(key.match(/^table$/i))
    {
      table = parseInt(data);
      if(isNaN(table))
        table = 0
    }
    else if(key.match(/^code$/i))
    {
      code = parseInt(data);
      if(isNaN(code))
        code = 0
    }
    else if(key.match(/^url$/i))
      url = data
  }
  var nMode = parseInt(mode);
  if(isNaN(nMode))
    nMode = 0;
  if(nMode < 0 || nMode > 2)
    nMode = 0;
  $('div[id^=' + TemplateSettings.guidelineDescIdPrefix + ']').css('display',nMode == 0 || nMode == 1 ? 'block' : 'none');
  $('div[id^=' + TemplateSettings.guidelineItemIdPrefix + ']').css('display',nMode == 0 || nMode == 2 ? 'block' : 'none')
};
Guideline.viewPage = function(url, target, level, figure, table, code)
{
  var urls = url.split('#');
  var loc = urls[0] + '?level=' + level + '&figure=' + figure + '&table=' + table + '&code=' + code + (urls.length > 1 ? '#' + urls[1] : (''));
  if(target != null && target != '')
    location.href = loc;
  else
    location.href = loc
};
var Search = function(){};
Search.resultCount = 0;
Search.search = function(query, msgId, dstId, api, skip)
{
  var sobj = document.getElementById(msgId);
  var dobj = document.getElementById(dstId);
  if(sobj == null || dobj == null)
    return;
  if(typeof jQuery != 'function')
  {
    alert(LocaleString.lcStrMessageNeedJQuery);
    return
  }
  if(Search.indexData == null)
    return;
  if($('div#' + dstId).html() != '')
    return;
  Search.resultCount = 0;
  $('div#' + msgId).html(LocaleString.lcStrMessageSearching);
  var array = new Array(0);
  for(var n = 0; n < Search.indexData.length; n++)
  {
    var data = Search.indexData[n];
    if(data == null)
      continue;
    if(data.length < 4)
      continue;
    if(!api && data[3] == 1)
      continue;
    var ret = Search.matchQuery(query,data,dstId,msgId);
    if(ret != null)
      array.push(ret)
  }
  array.sort(Search.resultSorter);
  while(skip > array.length)
    skip -= TemplateSettings.searchResultCountPerPage;
  if(skip < 0)
    skip = 0;
  for(var n = 0; n < array.length; n++)
  {
    var data = array[n];
    if(data == null)
      continue;
    if(data.length < 4)
      continue;
    if(n < skip)
      continue;
    var url = data[0];
    var title = data[1];
    url = Search.addQueryToURL(url,query,'highlighttext');
    if(url.length > 1 && url[0] == "/")
      url = url.slice(1);
    var ext = '';
    ext += '<p class="search_result_title">';
    ext += '<a href="' + url + '">' + title + '</a> (score: ' + data[3] + ')<br />';
    ext += '</p>';
    ext += '<p class="search_result_line">' + data[2] + '</p>';
    $('div#' + dstId).append($(ext));
    Search.resultCount++;
    if(Search.resultCount >= TemplateSettings.searchResultCountPerPage)
      break
  }
  var msgBtn = '';
  if(skip > 0)
    msgBtn += ' <input type="button" onclick="btnClick(\'' + (skip - TemplateSettings.searchResultCountPerPage) + '\')" value="' + LocaleString.lcStrLabelSearchPrev.replace('%c%',TemplateSettings.searchResultCountPerPage) + '">';
  if(skip + TemplateSettings.searchResultCountPerPage < array.length)
    msgBtn += ' <input type="button" onclick="btnClick(\'' + (skip + TemplateSettings.searchResultCountPerPage) + '\')" value="' + LocaleString.lcStrLabelSearchNext.replace('%c%',TemplateSettings.searchResultCountPerPage) + '">';
  if(msgBtn != '')
    $('div#' + dstId).append($('<div>' + msgBtn + '</div'));
  var msg = '';
  msg += '<hr class="' + TemplateSettings.searchMessageLineStyle + '">';
  msg += LocaleString.lcStrLabelSearchResult.replace('%r%','' + array.length);
  if(array.length > 0)
    msg += LocaleString.lcStrLabelSearchView.replace('%s%','' + (skip + 1)).replace('%e%','' + (skip + Search.resultCount));
  msg += msgBtn;
  msg += '<hr class="' + TemplateSettings.searchMessageLineStyle + '">';
  $('div#' + msgId).html(msg)
};
Search.resultSorter = function(dataA, dataB)
{
  if(dataA[3] == dataB[3])
  {
    if(dataA[1] < dataB[1])
      return-1;
    return 1
  }
  return dataB[3] - dataA[3]
};
Search.addQueryToURL = function(url, query, word)
{
  if(url == null || query == null)
    return'';
  var posA = url.indexOf('?');
  var posB = url.indexOf('#');
  if(posB < 0)
    return url + (posA < 0 ? '?' + word + '=' : '&' + word + '=') + encodeURIComponent(query);
  return url.slice(0,posB) + (posA < 0 ? '?' + word + '=' : '&' + word + '=') + encodeURIComponent(query) + url.slice(posB)
};
Search.parseQuery = function(query)
{
  var array = query.split(' ');
  var ret = new Array(0);
  var start = 0;
  var flag = false;
  var invert = false;
  var work = '';
  while(start < array.length)
  {
    var str = array[start];
    if(!flag)
      if(str.charAt(0) == '-')
      {
        str = str.slice(1);
        invert = true
      }
      else
        invert = false;
    else
      work += ' ';
    flag = Search.checkDQ(str,-1,flag);
    if(flag)
      work += str.replace(/"/g,'');
    else
    {
      work += str.replace(/"/g,'');
      ret.push((invert ? '\t' : '') + work);
      work = ''
    }
    start++
  }
  if(work != '')
    ret.push((invert ? '\t' : '') + work);
  return ret
};
Search.checkDQ = function(str, pos, flag)
{
  var ret = flag;
  var p = str.indexOf('"',pos + 1);
  if(p >= 0)
    ret = Search.checkDQ(str,p,!ret);
  return ret
};
Search.matchQuery = function(query, data, dstId, msgId)
{
  var array = Search.parseQuery(query);
  var find = true;
  var rst = '';
  var filtered = data[2];
  var findPos = filtered.length;
  var onlyInvert = true;
  var findInvert = false;
  var score = 0;
  for(var n = 0; n < array.length; n++)
  {
    if(array[n] == '')
      continue;
    if(array[n].match(/^ +$/))
      continue;
    var invert = false;
    var str = array[n];
    if(str.charAt(0) == '\t')
    {
      str = str.slice(1);
      if(str.match(/^ +$/))
        continue;
      invert = true
    }
    else
      onlyInvert = false;
    str = Search.escapeRegex(str);
    var re = new RegExp(str,'i');
    var pos = filtered.search(re);
    var reS = new RegExp(str,'ig');
    var match = filtered.match(reS);
    if(match != null)
      score += match.length;
    var flag = pos >= 0;
    if(invert)
    {
      if(flag)
      {
        findInvert = true;
        find = false
      }
    }
    else
    {
      if(findInvert)
        continue;
      find &= flag;
      if(!flag)
        continue;
      if(findPos > pos)
        findPos = pos
    }
  }
  if(find && !findInvert && !onlyInvert)
  {
    if(findPos == filtered.length)
      findPos = 0;
    var start = findPos - TemplateSettings.searchResultDigestLength;
    if(start < 0)
      start = 0;
    rst = Search.escapeHtml(filtered.substr(start,TemplateSettings.searchResultDigestLength * 2));
    var url = data[0];
    var title = data[1];
    if(url.length > 1 && url[0] == "/")
      url = url.slice(1);
    var ext = '';
    var strReg = '';
    for(var n = 0; n < array.length; n++)
    {
      if(array[n] == '')
        continue;
      if(array[n].match(/^ +$/))
        continue;
      if(array[n].charAt(0) == '\t')
        continue;
      var str = Search.escapeRegex(array[n]);
      if(strReg != '')
        strReg += '|';
      strReg += str
    }
    if(strReg != '')
    {
      var reR = new RegExp(strReg,'ig');
      rst = rst.replace(reR,Search.highlighter)
    }
    ext += (start > 0 ? '...' : '') + rst + (start + TemplateSettings.searchResultDigestLength * 2 < filtered.length ? '...' : '') + '<br />';
    return new Array(url,title,ext,score)
  }
  return null
};
Search.highlighter = function(str)
{
  return'<span class="search_highlight">' + str + '</span>'
};
Search.escapeRegex = function(str)
{
  if(str == null)
    return'';
  if(typeof str != 'string')
    return'';
  var ret = str;
  ret = ret.replace(/\\/g,'\\\\');
  ret = ret.replace(/\^/g,'\\^');
  ret = ret.replace(/\$/g,'\\$');
  ret = ret.replace(/\./g,'\\.');
  ret = ret.replace(/\*/g,'\\*');
  ret = ret.replace(/\+/g,'\\+');
  ret = ret.replace(/\|/g,'\\|');
  ret = ret.replace(/\(/g,'\\(');
  ret = ret.replace(/\)/g,'\\)');
  ret = ret.replace(/\[/g,'\\[');
  ret = ret.replace(/\]/g,'\\]');
  ret = ret.replace(/\{/g,'\\{');
  ret = ret.replace(/\}/g,'\\}');
  ret = ret.replace(/\//g,'\\/');
  return ret
};
Search.escapeHtml = function(html)
{
  if(html == null)
    return'';
  if(typeof html != 'string')
    return'';
  var ret = html;
  ret = ret.replace(/&/g,'&amp;');
  ret = ret.replace(/</g,'&lt;');
  ret = ret.replace(/>/g,'&gt;');
  ret = ret.replace(/"/g,'&quot;');
  ret = ret.replace(/\n/g,'<br />');
  ret = ret.replace(/\t/g,'&nbsp;&nbsp;');
  return ret
};
Search.filterHtml = function(html)
{
  if(html == null)
    return'';
  if(typeof html != 'string')
    return'';
  var ret = html;
  ret = Search.removeTagAndText(ret,'head');
  ret = Search.removeTagAndText(ret,'noscript');
  ret = Search.removeTagAndText(ret,'script');
  ret = Search.removeTagAndText(ret,'style');
  ret = Search.extractTextFromTag(ret,'pre','','','',true);
  ret = ret.replace(/\n/g,'');
  ret = Search.extractTextFromTag(ret,'div','class="(table|figure|code)"','','\n',false);
  ret = ret.replace(/<br( +[^>]*\/?>|>)/ig,'\n');
  ret = ret.replace(/<(th|td|dd)( +[^>]*>|>)/ig,'\t');
  ret = ret.replace(/<\/(h[1-6]|tr|p|ul|ol|dt|dd) *>/ig,'\n');
  ret = ret.replace(/<li( +[^>]*>|>)/ig,'\n');
  ret = ret.replace(/<[^>]*>/g,'');
  ret = ret.replace(/&lt;/ig,'<');
  ret = ret.replace(/&gt;/ig,'>');
  ret = ret.replace(/&quot;/ig,'"');
  ret = ret.replace(/&nbsp;/ig,' ');
  ret = ret.replace(/&amp;/ig,'&');
  ret = ret.replace(/ +/g,' ');
  ret = ret.replace(/ \n/g,'\n');
  ret = ret.replace(/\n+/g,'\n');
  return ret
};
Search.removeTagAndText = function(html, tag)
{
  if(html == null)
    return'';
  if(typeof html != 'string')
    return'';
  if(tag == null)
    return'';
  if(typeof tag != 'string')
    return'';
  var ret = html;
  var pos = 0;
  var reTagS = new RegExp('<' + tag + '( +[^>]*>|>)','i');
  var reTagE = new RegExp('<\/' + tag + ' *>','i');
  while(pos >= 0)
  {
    pos = ret.search(reTagS);
    if(pos < 0)
      break;
    var matchS = ret.match(reTagS);
    var lenS = matchS[0].length;
    var work = ret.slice(pos + lenS);
    var epos = work.search(reTagE);
    if(epos < 0)
    {
      epos = pos + lenS;
      ret = ret.slice(0,pos) + ret.slice(epos)
    }
    else
    {
      var matchE = work.match(reTagE);
      var lenE = matchE[0].length;
      ret = ret.slice(0,pos) + work.slice(epos + lenE)
    }
  }
  return ret
};
Search.extractTextFromTag = function(html, tag, attr, before, after, convertLF)
{
  if(html == null)
    return'';
  if(typeof html != 'string')
    return'';
  if(tag == null)
    return html;
  if(typeof tag != 'string')
    return html;
  var strAttr = '';
  if(attr != null && typeof attr == 'string')
    strAttr = attr;
  var strBefore = '';
  if(before != null && typeof before == 'string')
    strBefore = before;
  var strAfter = '';
  if(after != null && typeof after == 'string')
    strAfter = after;
  var ret = html;
  var pos = 0;
  var reTagS = new RegExp('<' + tag + (strAttr != '' ? ' ' + strAttr : '') + '( [^>]*[^\/]>|>)','i');
  var reTagE = new RegExp('<\/' + tag + ' *>','i');
  while(pos >= 0)
  {
    pos = ret.search(reTagS);
    if(pos < 0)
      break;
    var matchS = ret.match(reTagS);
    var lenS = matchS[0].length;
    var work = ret.slice(pos + lenS);
    var epos = work.search(reTagE);
    if(epos < 0)
      break;
    var matchE = work.match(reTagE);
    var lenE = matchE[0].length;
    if(convertLF)
      ret = ret.slice(0,pos) + strBefore + work.slice(0,epos).replace(/\n/g,'<br />') + strAfter + work.slice(epos + lenE);
    else
      ret = ret.slice(0,pos) + strBefore + work.slice(0,epos) + strAfter + work.slice(epos + lenE)
  }
  return ret
}
